  @echo off
setlocal enabledelayedexpansion enableextensions


	REM #############################################################################
	REM 
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	if "%~1" equ "" ( goto :HELP )

	goto :SETUP %*

:CHECKHELP_END

	Flowchart:

	New changes 09/21/2011:
		
	


	REM #############################################################################
	REM 
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_log!
	!bat_log! =============================================================
	!bat_log! %date% %time% - Version: !bat_vers! - [%~dpnx0 %*]
	!bat_log! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!

	call "!bat_exedir!\ReadParams.bat"


rem	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
rem	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
rem		echo     ERROR: You must start from x:\CAMS directory. 
rem		exit /b 1
rem	)
	
	set bat_caldir=!bat_startlocation!\Cal
rem	set bat_logfile=!bat_logdir!\CreateCameraListFile.bat.log
	

	set bat_capturedfilesdir=%~1

	set bat_GCFC_name=GCFC.log
	set bat_GCFC_dir=!bat_capturedfilesdir!
	set bat_GCFC_tempfile=!bat_GCFC_dir!\!bat_GCFC_name!
	
	set bat_archivedfilesdir_temp=!bat_GCFC_dir:CapturedFiles=ArchivedFiles!

	call :MAIN %*
goto :DONE





	REM #############################################################################
	REM 
	rem Loop to read the detect file.
	rem The goal is to extract from the detect file:
	rem  bat_ffdir, bat_caldir, bat_calfilename, bat_camera
:MAIN
!bat_pushlog! [CALL !bat_batchfile!:MAIN] "!bat_detectfile_temp!" [%*]
	set bat_retval=success
	set bat_returncode=0

	if exist "!bat_archivedfilesdir_temp!\FF_*_0000000.*" (
		!bat_logexec! COPY /Y "!bat_archivedfilesdir_temp!\FF_*_0000000.*" "!bat_GCFC_dir!"
	)

	call :GETCAMERAFROMCAPTURED "!bat_capturedfilesdir!"

:MAIN_END
!bat_poplog! [RETURN !bat_batchfile!:MAIN] [!bat_retval!, bat_camera=!bat_camera!, bat_camera_list=!bat_camera_list!, file=!bat_GCFC_tempfile!]
!bat_log!
!bat_return!







	REM #############################################################################
	REM 
:GETCAMERAFROMCAPTURED
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERAFROMCAPTURED] %*

	if exist "!bat_GCFC_tempfile!" (
		call :GETCAMERALIST "%~1"
		goto :GETCAMERAFROMCAPTURED_END
	)

	set bat_camera_temp=
	set bat_camera_prev=
	set bat_camera_list=
	set /a bat_camera_count=0
	
	if not defined bat_capturedfilesdir (
		goto :GETCAMERAFROMCAPTURED_END
	)


	if exist "%~1\FF*.bin" (
			REM Fetch the number of FF files
			REM
		set /a bat_capturedcount_temp=0
		for               /f "usebackq tokens=1*" %%x in  (`dir "%~1\FF*.bin" /a-d /on^|findstr /i /r /c:" File(s) "`) do (
			set /a bat_capturedcount_temp=%%x
		)

		if defined bat_capturedcount_temp (
			!bat_TITLEWAIT! Scanning [!bat_capturedcount_temp!] FF files...
		) else (
			!bat_TITLEWAIT!
		)
	)

	set /a bat_capturedcount=0
	
	if exist "%~1\FF_??????_*.bin" (
			rem create the file in sorted order...
			
		set bat_searchspec=%~1\FF_??????_*_0000000.bin
		if not exist "!bat_searchspec!" (
			set bat_searchspec=%~1\FF_??????_*_*.bin
		)
		
		!bat_pushlog! for /f "usebackq tokens=*" DDa in ^(`dir "!bat_searchspec!" /b /a-d /on`^) do ...
		for               /f "usebackq tokens=*" %%a in  (`dir "!bat_searchspec!" /b /a-d /on`) do (
			set /a bat_capturedcount+=1

			set bat_temp=%%~nxa

			set bat_camera_temp=000000!bat_temp:~3,6!
			set bat_camera_temp=!bat_camera_temp:~-6!

			if /i "!bat_camera_prev!" neq "!bat_camera_temp!" (
				if not defined bat_camera_list (
					!bat_log! 'a        ADDING [!bat_camera_temp!] TO CAMERA LIST: "!bat_GCFC_name!": !bat_temp!
					set bat_camera_list=!bat_camera_temp!
					set bat_camera_prev=!bat_camera_temp!
					set /a bat_camera_count+=1
					echo.!bat_camera_temp!>"!bat_GCFC_tempfile!"

						rem If this is the first camera in the sorted list, then return it as the 
						rem bat_camera for autocams menu.
					set bat_camera=!bat_camera_temp!
				) else (
					call :CHECK_GCFC "!bat_camera_temp!"
					if not defined bat_GCFC_found (
						!bat_log! 'c        ADDING [!bat_camera_temp!] TO CAMERA LIST: "!bat_GCFC_name!": !bat_temp!
						set bat_camera_list=!bat_camera_list!!bat_camera_temp!
						set bat_camera_prev=!bat_camera_temp!
						set /a bat_camera_count+=1
						echo.!bat_camera_temp!>>"!bat_GCFC_tempfile!"
					)
				)

			)

			rem TITLE %%a
			rem !bat_log! ==========================%%a
			if /i "!bat_camera_temp!" neq "" (
				set bat_camera=!bat_camera_temp!
			)
		)
		!bat_pop!
	)
	
	
	set bat_camera_list=
	
	if exist "!bat_GCFC_tempfile!" (
		!bat_log! Sorting camera list in "!bat_GCFC_tempfile!" - before...
		!bat_logexeclog! type "!bat_GCFC_tempfile!"

		!bat_log!
		!bat_logexeclog! sort "!bat_GCFC_tempfile!" /output "!bat_GCFC_tempfile!"
		!bat_log!
		!bat_log! Sorting camera list in "!bat_GCFC_tempfile!" - after...
		!bat_logexeclog! type "!bat_GCFC_tempfile!"

		call :GETCAMERALIST
	) else (
		!bat_logexeclog! set bat_returncode=1
		!bat_logexeclog! set bat_retval=failed
	)
	
:GETCAMERAFROMCAPTURED_END
!bat_poplog! [RETURN !bat_batchfile!:GETCAMERAFROMCAPTURED] [bat_returncode=!bat_returncode!, bat_retval=!bat_retval!,
!bat_log! `                                                  bat_camera=!bat_camera!, 
!bat_log! `                                                  bat_camera_list=!bat_camera_list!, 
!bat_log! `                                                  bat_capturedcount=!bat_capturedcount!, 
!bat_log! `                                                  file=!bat_GCFC_tempfile!]
!bat_log!
!bat_return!





	REM #############################################################################
	REM 
:CHECK_GCFC
rem !bat_pushlog! [CALL !bat_batchfile!:CHECK_GCFC] [%*]
	set bat_GCFC_found=
	for /f "usebackq tokens=*" %%x in (`type "!bat_GCFC_tempfile!"`) do (
		if /i "%~1" equ "%%~x" (
			set bat_GCFC_found=true
		)
	)
:CHECK_GCFC_END
rem !bat_poplog! [RETURN !bat_batchfile!:CHECK_GCFC] [%~1, bat_GCFC_found=!bat_GCFC_found!]
rem !bat_log!
!bat_return!






	REM #############################################################################
	REM 
:GETCAMERALIST
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERALIST] %*
	!bat_pushlog! call "!bat_exedir!\GetCameraList.bat" "!bat_capturedfilesdir!"
	              call "!bat_exedir!\GetCameraList.bat" "!bat_capturedfilesdir!"
	!bat_pop!
:GETCAMERALIST_END
!bat_poplog! [RETURN !bat_batchfile!:GETCAMERALIST] [bat_camera_list=!bat_camera_list!]
!bat_return!




	REM #############################################################################
	REM 
:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS] %*
	!bat_log! call "!bat_exedir!\ReadParams.bat"
	          CALL "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!









	REM #############################################################################
	REM 
:HELP
	@echo off
	echo.
	echo.%~nx0 "captured files dir"
	echo.
	echo.Creates the GCFC.log file in the CapturedFiles directory.  The GCFC.log 
	echo.is a text file that contains a list of camera numbers that are used in the 
	echo.CapturedFiles dir, based on the FF files. 
	echo.
	echo.Usage: %~nx0  "C:\CAMS\CapturedFiles\2012_08_11_03_44_55"
	echo.
	echo.Returns using ENDLOCAL
	echo.    bat_retval          success if ok.  failed if problems
	echo.    bat_camera_list     
	echo.    bat_camera_first=%bat_camera_first%
	echo.    bat_camera_last=%bat_camera_last%
	echo.    bat_camera_list=%bat_cameralist2%
	echo.    bat_camera=%bat_camera%
	echo.    bat_capturedcount_temp=%bat_capturedcount_temp%
	echo.
	echo.Note: GCFC stands for "GetCameraFromCaptured", which probably doesn't always
	echo.      apply anymore. But that was the original intent.
	echo.
	echo.
	echo.
exit /b -99



	REM #############################################################################
	REM 
:DONE
	!bat_poplog! :DONE with %~f0 %*
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!

	ENDLOCAL & IF "%BAT_RETVAL%" NEQ "" (
		SET bat_retval=%bat_retval%
		set bat_camera_first=%bat_camera_first%
		set bat_camera_last=%bat_camera_last%
		SET bat_camera_list=%bat_cameralist2%
		SET bat_camera=%bat_camera%
		SET bat_capturedcount_temp=%bat_capturedcount_temp%
	) ELSE ( echo.%bat_retval%)
exit /b 0
