@echo off
setlocal enableextensions enabledelayedexpansion




	REM ###########################################################################
	REM
	
:CHECKHELP
	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
    
rem	if "%~1" equ "" (goto :HELP)
goto :SETUP %*




	REM ###########################################################################
	REM
	
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"


	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 %*
	!bat_echolog!


	set bat_spacer=                                                  

REM	if exist "!bat_cams2globalINI!" (
		REM Needs to be able to handle if there are multiple CAMS instances, e.g. Fremont Peak, Forest Hill, etc. 
		CALL "!bat_exedir!\ReadCams2Global.bat"
		
		!bat_logexeclog! set /a bat_boards_max=!bat_CAMS2BOARDS.number_of_boards!-1
		!bat_log! set bat_boards_max=!bat_boards_max!
REM	)
	
	call :PARSEARGS %*
	
goto :MAIN %*






	REM ###########################################################################
	REM
	
:PARSEARGS
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*

	set bat_returncode=0

	(echo.%*|find /i "/all") && (
		set bat_all=true
	) || (
		set bat_all=false
	)
	
	if /i "%~1" equ "/all" (
		SHIFT
	)
	
	if "%~1" equ "" (
		!bat_logexeclog! set bat_camera_spec=??????
		!bat_logexeclog! set bat_outputfile_name=Pointing_ALL.txt
	) else (
		                 set bat_camera_spec=000000%~1
		!bat_logexeclog! set bat_camera_spec=!bat_camera_spec:~-6!
		!bat_logexeclog! set bat_outputfile_name=Pointing_!bat_camera_spec!.txt
		!bat_logexeclog! set bat_outputfile_name=!bat_outputfile_name:?=~!
	)
	

:PARSEARGS_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 0	:PARSEARGS_END
!bat_return! !bat_returncode!




	REM ###########################################################################
	REM
	
:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %*

rem	echo.if exist "!bat_camsdir!\CAL\!bat_outputfile_name!" 
	if      exist "!bat_camsdir!\CAL\!bat_outputfile_name!" (
		!bat_logexeclog! DEL /q "!bat_camsdir!\CAL\!bat_outputfile_name!"
	)
	
rem	set bat_outputfile=!bat_camsdir!\CAL\!bat_outputfile!
	!bat_logexeclog! set bat_outputfile=!bat_camsdir!\CAL\!bat_outputfile_name!

	set bat_calfiledate=

		REM This loop iterates throug the different instances of the Cams2 software based on
		REM the Cams2Global.ini file.
		
rem !bat_pause! aaa   bat_camsdir=!bat_camsdir!, bat_boards_max=!bat_boards_max!

	for /L %%a in (0,1,!bat_boards_max!) do (
		set bat_board=%%a
		set bat_camsdir=!bat_CAMS2DIR.%%a!
		set bat_caldir=!bat_camsdir!\CAL

rem !bat_pause! bbb   a=%%a, bat_camsdir=!bat_camsdir!, bat_boards_max=!bat_boards_max!

		
		call :LIST
	)

:MAIN_END
!bat_poplog! [:MAIN_END !bat_batchfile!:MAIN] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 0	:MAIN_END
goto :DONE




	REM ###########################################################################
	REM
	
:LIST
!bat_pushlog! [!bat_batchfile!:LIST]
	!bat_logexeclog! set bat_camsdir
	!bat_logexeclog! set bat_caldir=!bat_camsdir!\Cal
	!bat_logexeclog! set bat_outputfile=!bat_caldir!\!bat_outputfile_name!

	!bat_log! bat_outputfile=!bat_outputfile!

	echo.>>"!bat_outputfile!"
	echo.>>"!bat_outputfile!"

rem !bat_pause! [LIST]

	echo.=============================================================>>"!bat_outputfile!"
	echo.%date% %time% - Version: !bat_vers! - %~dpnx0 %*>>"!bat_outputfile!"
	echo.>>"!bat_outputfile!"

		REM Sets the value for bat_calfiledate. 
	call :GETCALFILEDATE

	echo.bat_calfiledate=!bat_calfiledate!>>"!bat_outputfile!"
	echo."!bat_caldir!\CAL_!bat_camera_spec!_????????_*.txt" >>"!bat_outputfile!"
	echo.>>"!bat_outputfile!"
	echo.                                            Height    Cam                              Focal Fov    Fov               >>"!bat_outputfile!"
	echo.                   Lat         Long          WGS84     ID  Azimuth    Elev Color         Len Wt      Ht      Tilt  Scale  O-C   Accuracy           File                                Comments                         >>"!bat_outputfile!"
	echo.                 --------- ----------- ----------- ------ -------- ------- --------- ------- ---------- --------- ------ ----- -----------------  ----------------------------------   --------------------------------   >>"!bat_outputfile!"


	!bat_echolog! bat_calfiledate=!bat_calfiledate!
	!bat_echolog! "!bat_caldir!\CAL_!bat_camera_spec!_????????_*.txt" 
	!bat_echolog! 
	!bat_echolog! `                                            Height    Cam                              Focal Fov    Fov               
	!bat_echolog! `                   Lat         Long          WGS84     ID  Azimuth    Elev Color         Len Wt      Ht      Tilt  Scale  O-C   Accuracy           File                                Comments                         
	!bat_echolog! `                 --------- ----------- ----------- ------ -------- ------- --------- ------- ---------- --------- ------ ----- -----------------  ----------------------------------   --------------------------------   


	set bat_tempdate=

rem	!bat_logexeclog! dir "!bat_caldir!\CAL_!bat_camera_spec!_????????_*.txt" /a-d /b /o-n

	set /a bat_countfile=0

	!bat_pushlog! for  /f "usebackq tokens=*" ..a in ^(`dir "!bat_caldir!\CAL_!bat_camera_spec!_!bat_calfiledate!_*.txt" /a-d /b /o-n`^) do ^(
	for                /f "usebackq tokens=*" %%a in  (`dir "!bat_caldir!\CAL_!bat_camera_spec!_!bat_calfiledate!_*.txt" /a-d /b /o-n`) do (
	
		!bat_logexeclog! set bat_filename=%%a

		if not defined bat_calfiledate (
			!bat_logexeclog! set bat_calfiledate=!bat_filename:~11,8!
		)
		
		set bat_tempdate=!bat_filename:~11,8!
		
		if /i "!bat_all!" NEQ "true" (
			if "!bat_calfiledate!" NEQ "!bat_tempdate!" (
 !bat_log! if "!bat_calfiledate!" NEQ "!bat_tempdate!"
				goto :LIST_BREAK
			)
		)
		
		set /a bat_countfile+=1

		set /a bat_count=0
		rem echo.for /f "useback tokens=1-10 delims==" ..b in ^(`findstr /i /c:"Camera number" /c:"azim" /c:"elev" /c:"calibration date" /c:"calibration time" /c:"fov dimension" /c:"plate scale" /c:"cam tilt" /c:"camera description" /c:"focal length" /c:"focal ratio"   "!bat_caldir!\%%a"`^) do ^(
		!bat_pushlog! for  /f "useback tokens=1-2 delims==" ..b in ^(`type "!bat_caldir!\%%a"`^) do ^(
		for                /f "useback tokens=1-2 delims==" %%b in  (`type "!bat_caldir!\%%a"`) do (
		
			set /a bat_count+=1
			set bat_temp=%%c

rem			!bat_log! !bat_count!	[!bat_temp!]	[%%b, %%c]

			if !bat_count! equ 1 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_CameraNumber=!bat_retval!
			)

			if !bat_count! equ 2 (
				call :FILL_LEFT "!bat_temp!" 10
				set bat_CalDate=!bat_retval!
			)

			if !bat_count! equ 3 (
				call :FILL_LEFT "!bat_temp!" 12
				set bat_CalTime=!bat_retval!
			)

			if !bat_count! equ 4 (
				call :FILL_RIGHT "!bat_temp!" 11
				set bat_Long=!bat_retval!
			)

			if !bat_count! equ 5 (
				call :FILL_RIGHT "!bat_temp!" 9
				set bat_Lat=!bat_retval!
			)

			if !bat_count! equ 6 (
				call :FILL_RIGHT "!bat_temp!" 11
				set bat_Height=!bat_retval!
			)

			if !bat_count! equ 7 (
				for /f "tokens=1,2 delims=x" %%k in ("!bat_temp!") do (
					call :FILL_RIGHT "%%k" 5
					set bat_FovH=!bat_retval!

					call :FILL_RIGHT "%%l" 5
					set bat_FovW=!bat_retval!
				)&	rem for /f "tokens=1,2..." ..k
			)

			if !bat_count! equ 8 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_Scale=!bat_retval!
			)

			if !bat_count! equ 9 (
				call :FILL_RIGHT "!bat_temp!" 8
				set bat_roll=!bat_retval!
			)

			if !bat_count! equ 10 (
				call :FILL_RIGHT "!bat_temp!" 8
				set bat_Tilt=!bat_retval!
			)

			if !bat_count! equ 14 (
				call :FILL_RIGHT "!bat_temp!" 8
				set bat_Az=!bat_retval!
			)

			if !bat_count! equ 15 (
				call :FILL_RIGHT "!bat_temp!" 7
				set bat_Elev=!bat_retval!
			)

			if !bat_count! equ 19 (
				call :STRIP_WHITESPACE "!bat_temp!" 30
				set bat_Descr=!bat_retval!
			)

			if !bat_count! equ 21 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_FocalLength=!bat_retval!
			)

			if !bat_count! equ 22 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_FocalRatio=!bat_retval!
			)

			if !bat_count! equ 23 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_PitchH=!bat_retval! um
			)

			if !bat_count! equ 24 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_PitchV=!bat_retval! um
			)

			if !bat_count! equ 47 (
				call :FILL_RIGHT "!bat_temp!" 23
				set bat_OC=!bat_retval!
			)

		)&	rem for...
		!bat_poplog! ^)

		set bat_countstr=      !bat_countfile!
		set bat_countstr=!bat_countstr:~-6!
		
		
		
		set bat_output=!bat_countstr!  !bat_CameraNumber! !bat_Lat! !bat_Long! !bat_Height! !bat_CameraNumber! !bat_Az! !bat_Elev!            !bat_FocalLength! !bat_FovW! !bat_FovH! !bat_Tilt! !bat_scale! !bat_OC!  !bat_filename!  !bat_Descr! !bat_PitchH! x !bat_PitchV! [um]
		!bat_echolog! `!bat_output!
		echo.!bat_output!>>"!bat_outputfile!"
		
:LIST_BREAK
!bat_log! [GOTO :LIST_BREAK]
		
	)&	rem for...
	!bat_poplog! ^)



	echo.
	echo.
	!bat_echolog! Output is found in: "!bat_outputfile!"
	echo.     .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  
	echo.

:LIST_END
!bat_poplog! [RETURN !bat_batchfile!:LIST] [bat_returncode=!bat_returncode!, bat_calfiledate=!bat_calfiledate!]
!bat_log!
rem !bat_WAIT! 0	:LIST_END
!bat_return! !bat_returncode!





	REM ###########################################################################
	REM FILL_RIGHT - Sets bat_retval to %1 with %2 number of spaces with RIGHT padding.
	
:FILL_RIGHT 
	set bat_retval=!bat_spacer!%~1
rem	echo.[[[[set bat_retval=!bat_retval:~-%~2!]]]]]]]]]
	set bat_retval=!bat_retval:~-%~2!
exit /b 0




	REM ###########################################################################
	REM FILL_LEFT - Sets bat_retval to %1 with %2 number of spaces with LEFT padding. 
	
:FILL_LEFT 
	set bat_retval=%~1!bat_spacer!
	set bat_retval=!bat_retval:~0,%~2!
	
exit /b 0





	REM ###########################################################################
	REM STRIP_WHITESPACE - Sets bat_retval and strips off any trailing whitespace.
	
:STRIP_WHITESPACE 
	set bat_retval=
	
	set bat_retval=%~1

exit /b 0




	REM ###########################################################################
	REM Determine the setting for bat_calfiledate					:GETCALFILEDATE
	REM
	REM It establishes the sort order by performing the following command and reading the results:
	REM    DIR /b /on /a-d "!bat_caldir!\CAL_!bat_camera_spec!_????????_*.txt"
	REM
	REM It establishes the bat_calfiledate from the last entry in the DIR listing. 
	REM Returns:  bat_calfiledate
	REM 
	
:GETCALFILEDATE
!bat_pushlog! [!bat_batchfile!:GETCALFILEDATE]

	for /f "usebackq tokens=*" %%a in (`dir /b /on /a-d "!bat_caldir!\CAL_!bat_camera_spec!_????????_*.txt"`) do (
		set bat_tempcalfile=%%a
		set bat_calfiledate=!bat_tempcalfile:~11,8!
	)

	if /i "!bat_calfiledate!" equ "" (
		set bat_calfiledate=????????
	)
	
	if /i "!bat_all!" equ "true" (
		set bat_calfiledate=????????
	)

:GETCALFILEDATE_END
!bat_poplog! [RETURN !bat_batchfile!:GETCALFILEDATE] [bat_returncode=!bat_returncode!, bat_calfiledate=!bat_calfiledate!]
!bat_log!
rem !bat_WAIT! 0	:GETCALFILEDATE_END
!bat_return! !bat_returncode!








	REM ###########################################################################
	REM HELP - 
	
:HELP
	echo.
	echo.Usage: %~nx0[/all] [camera] 
	echo.
	echo.Returns a list of pointing information for each calibration file found for the 
	echo.specified camera.  This list can be long, depending on how many calibration
	echo.files you have in your Cal dir.
	echo.
	echo.It is designed to be run from the "?:\cams2_queue\RunFolder", so that it can
	echo.use the "cams2global.ini" file settings that identify all the instances of 
	echo.Cams2_Boardx software and their Cal directories.  
	echo.
	echo.One of the purposes for this script is to determine if there is drift in the 
	echo.camera pointing.  It is for that reason that the cameras are listed in camera
	echo.sorting order.
	echo.
	echo.Note: The columns are presented in the order they are input into the 
	echo.      CAMS Pointing Tool to facilitate date entry to create your laydowns.
	echo.
	echo.      http://www.davesamuels.com/cams/camspointing/scripts/latlong.html
	echo.
	echo.      The report is also saved in a text file in the associated Cal directories. 
	echo.
	echo.Where:
	echo.   /all      If present, it reports all dates in reverse date order, based on the 
	echo.             Windows file sort order of the CAL files in the Cal directories.  
	echo.             If absent, the first matching camera establishes the date and then 
	echo.             it will only report CAL files with that date.
	echo.
	echo.   camera    If absent, all cameras in the CAL dir are included in the report. 
	echo.             If present, specifies  the camera spec [wildcards supported] for 
	echo.             filtering the list.
	echo.               
	echo.Examples:
	echo.    %~nx0
	echo.      Reports on all CAL files using the date of the most-recent CAL file in the Cal dirs. 
	echo.
	echo.    %~nx0 7??
	echo.      Reports on all CAL files that match "CAL_0007??_*.txt" filespec corresponding to 
	echo.      the CAMS date of the most recent Cal file in the Cal dirs. 
	echo.
	echo.    %~nx0 /all 258
	echo.      Reports in reverse date order all the calibrations for camera 258.  This is how you
	echo.      can determine the Alt/AZ drift of the mounting. 
	echo.
	echo.    If  there are multiple calibrations for a camera on the same date, they will all be included in the report
	echo.    in reverse date/time order. 
	echo.
exit /b 99





	REM ###########################################################################
	REM DONE - 
	
:DONE

