
@echo off
setlocal enableextensions enabledelayedexpansion

	REM #########################################################################
	REM 

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	
rem 	if /i "%~1" EQU "" (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

	REM #########################################################################
	REM 

:SETUP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	CALL "!bat_exedir!\ReadParams.bat"
	
	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!


rem set bat_indent_log_debug=true

		rem Get the bat_capturedfilesdir value
	CALL "!bat_exedir!\ReadConfig.bat"

	CALL "!bat_exedir!\ReadCams2Global.bat"

	set /a bat_boards_max=!bat_CAMS2BOARDS.number_of_boards!-1
	!bat_log! set bat_boards_max=!bat_boards_max!
	
	set bat_sourcedir=%~1
	set bat_capturesession=%~n1
	set bat_captureddate=!bat_capturesession:~0,10!
	set bat_capturedtime=!bat_capturesession:~-8!
	
	set bat_GCFC_tempfile=%~1\GCFC.log

goto :MAIN %*
	


	REM #########################################################################
	REM 

:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] [%*]
rem !bat_echolog! [!bat_batchfile!:MAIN] 1111111111111111111111111

	call :CREATE_GCFC

	call :CREATE_GROUPS
	
	call :WAIT_FOR_GROUPS

	call :RESTORE_GROUPS


!bat_echolog! [!bat_batchfile!:MAIN] 444444444444444444444444444444
:MAIN_END
!bat_poplog! [END-!bat_batchfile!:MAIN] - goto :DONE
goto :DONE


	

	
	REM #########################################################################
	REM Creating the camera list file: GCFC.log 
	REM
	REM This is a simplified version of the CreateCameraListFile.bat.
	REM

:CREATE_GCFC	
!bat_pushlog! [CALL !bat_batchfile!:CREATE_GCFC] [%*]
!bat_echolog! Creating the camera list file: GCFC.log 

	set bat_returncode=0
	
	set bat_camera=
	set bat_camera_list=
	set bat_camera_first=
	set bat_camera_last=

	set bat_camera_temp=
	set /a bat_camera_count=0

		rem After this call, you will have bat_camera, bat_camera_first, bat_camera_last.
	if exist "!bat_GCFC_tempfile!" (
		!bat_logexec! del /Q "!bat_GCFC_tempfile!"
	)
	
	if not exist "!bat_sourcedir!\FF_??????_*_0000000.bin" (
		set bat_returncode=1
		!bat_echolog!
		!bat_echolog! `   [!bat_batchfile!:CREATE_GCFC]   ERROR - File[s] Not found: "!bat_sourcedir!\FF_??????_*_0000000.bin"
		!bat_echolog!
		goto :CREATE_GCFC_END
	)
	
	for /f "usebackq tokens=*" %%a in (`dir /b /a-d /on "!bat_sourcedir!\FF_??????_*_0000000.bin"`) do (
		if /i "%%a" NEQ "" (
			set /a bat_camera_count+=1
			
			set bat_camera_temp=%%a
			set bat_camera_temp=!bat_camera_temp:~3,6!

				REM set bat_camera and bat_camera_first only on the first pass of the camera list.
			if not defined bat_camera (
				set bat_camera=!bat_camera_temp!
				set bat_camera_first=!bat_camera_temp!
			)

			echo.!bat_camera_temp!>>"!bat_GCFC_tempfile!"

			set bat_camera_last=!bat_camera_temp!
		)
	)
	
	if !bat_camera_count! GTR 1 (
		!bat_logexeclog! set bat_camera_list=!bat_camera_first!!bat_camera_last!
	) ELSE (
		!bat_logexeclog! set bat_camera_list=!bat_camera_first!
	)


	!bat_logexec! type "!bat_GCFC_tempfile!" 

:CREATE_GCFC_END
set bat_camera_temp=
!bat_poplog! [RETURN !bat_batchfile!:CREATE_GCFC] [bat_returncode=!bat_returncode!]
!bat_log! `                           [bat_camera_list=!bat_camera_list!, 
!bat_log! `                            bat_camera=!bat_camera!, 
!bat_log! `                            bat_camera_first=!bat_camera_first!,
!bat_log! `                            bat_camera_last=!bat_camera_last!,
!bat_log! `                            bat_GCFC_tempfile="!bat_GCFC_tempfile!",
!bat_log! `                            bat_camera_count=!bat_camera_count!]
!bat_log!
rem !bat_WAIT! 0     :CREATE_GCFC_END
!bat_return! !bat_returncode!

	

	


	REM #########################################################################
	REM Creates the 4 groups of FF files.  
	REM
	REM For performance, it will use wildcards instead of a listing file.
	REM
	REM

:CREATE_GROUPS	
!bat_pushlog! [CALL !bat_batchfile!:CREATE_GROUPS] [%*]
!bat_echolog! Creating the 4 groups of FF files. 

	set bat_returncode=0

	call "!bat_exedir!\stripZeros.bat" !bat_camera_first! bat_camera_first_stripped
	call "!bat_exedir!\stripZeros.bat" !bat_camera_last! bat_camera_last_stripped
	call "!bat_exedir!\stripZeros.bat" !bat_camera! bat_camera_stripped

	set /a bat_camera_count=!bat_camera_last_stripped!-!bat_camera_first_stripped! + 1
	
	set /a bat_camera_group_size=!bat_camera_count! / 4
	
	set /a bat_camera_start=!bat_camera_first_stripped!
	set /a bat_camera_end=!bat_camera_start! + !bat_camera_group_size!
	
	!bat_logexec! set bat_camera

	!bat_echolog! for /L ..a in ^(!bat_camera_start!, !bat_camera_group_size!, !bat_camera_last_stripped!^) do 
	for               /L %%a in  (!bat_camera_start!, !bat_camera_group_size!, !bat_camera_last_stripped!) do (
		!bat_pushecho! ^(
		
		!bat_logexec! set bat_camera_group_start=%%a
		
		set /a bat_camera_group_end=!bat_camera_group_start! + !bat_camera_group_size! - 1
		
		!bat_echolog! set /a bat_camera_group_end=!bat_camera_group_start! + !bat_camera_group_size! - 1

		!bat_logexec! set bat_camera_group


				REM Remove any matching dirs and files and create a fresh new folder.
			call :PREPARE_DIR "!bat_CAMS2QUEUE.queue_dir!\Temp\!bat_camera_group_start!"

			REM Loop through the groups 
		!bat_pushecho! for /L ..b in ^(!bat_camera_group_start!, 1, !bat_camera_group_end!^) do 
		for                /L %%b in  (!bat_camera_group_start!, 1, !bat_camera_group_end!) do (
			!bat_pushecho! ^(
			
			set bat_camera_temp_padded=
			!bat_logexeclog! set bat_camera_temp=%%b

				REM Pad the camera number with leading 0's to match the file name.
			set bat_camera_temp_padded=000000%%b
			set bat_camera_temp_padded=!bat_camera_temp_padded:~-6!
			
			!bat_logexec! set bat_camera_temp_padded

				REM Move the FF files belonging to the subgroup.
			CALL :MOVEFILES "!bat_sourcedir!\FF_!bat_camera_temp_padded!_*.bin"  "!bat_CAMS2QUEUE.queue_dir!\Temp\!bat_camera_group_start!"
			
			!bat_popecho! ^)
		)


		!bat_START! "FTP_ValidateFFfiles.exe !bat_CAMS2QUEUE.queue_dir!\Temp\!bat_camera_group_start!" /MIN "!bat_exedir!\FTP_ValidateFFfiles.exe"   "!bat_CAMS2QUEUE.queue_dir!\Temp\!bat_camera_group_start!"
		
		!bat_popecho! ^)
	)
	


:CREATE_GROUPS
!bat_poplog! [RETURN !bat_batchfile!:CREATE_GROUPS] [bat_returncode=!bat_returncode!]
!bat_echolog!
rem !bat_WAIT! 0     :CREATE_GROUPS_END
!bat_return! !bat_returncode!





	REM #########################################################################
	REM Prepares the target directories.
	REM
	REM Returns:
	REM  bat_returncode              0=ok 

:PREPARE_DIR
!bat_pushlog! [CALL !bat_batchfile!:PREPARE_DIR] %*
!bat_echolog! Preparing the target directories.

	set bat_returncode=0

	!bat_logexec! DEL /Q "%~1"
	!bat_logexec! RD  /Q "%~1"
	!bat_logexec! MD     "%~1"


:PREPARE_DIR_END
!bat_poplog! [RETURN !bat_batchfile!:PREPARE_DIR] [bat_returncode=!bat_returncode!, bat_targetdir="%~1"]
!bat_log!
rem !bat_WAIT! 0     :PREPARE_DIR_END
!bat_return! !bat_returncode!





	REM #########################################################################
	REM Moves all the files from the specified dir to the group dir.
	REM
	REM Returns:
	REM  bat_returncode              0=ok 

:MOVEFILES
!bat_pushlog! [CALL !bat_batchfile!:MOVEFILES] %*
!bat_echolog! Moving all the files from the specified source dir to the group dir.

	set bat_returncode=0

	!bat_echolog! MOVE /Y "%~1" "%~2"
	              MOVE /Y "%~1" "%~2">nul:


:MOVEFILES_END
!bat_poplog! [RETURN !bat_batchfile!:MOVEFILES] [bat_returncode=!bat_returncode!, bat_targetdir="%~1", "%~2"]
!bat_log!
rem !bat_WAIT! 0     :MOVEFILES_END
!bat_return! !bat_returncode!







	REM #########################################################################
	REM Waiting for all the groups to complete before moving the files back.
	REM
	REM Returns:
	REM  bat_returncode              0=ok 

:WAIT_FOR_GROUPS
!bat_pushlog! [CALL !bat_batchfile!:WAIT_FOR_GROUPS] %*
!bat_echolog! Waiting for all the groups to complete before moving the files back.

	set bat_returncode=0

	set /a bat_camera_start=!bat_camera_first_stripped!
	set /a bat_camera_end=!bat_camera_start! + !bat_camera_group_size!

	for /L %%a in (!bat_camera_start!, 4, !bat_camera_last_stripped!) do (
		!bat_logexec! set bat_camera_group_start=%%a
		set /a bat_camera_group_end=!bat_camera_group_start! + 4


			REM Loop through the groups 
		for /L %%b in (!bat_camera_group_start!, 1, !bat_camera_group_end!) do (

				REM Remove any matching dirs and files and create a fresh new folder.
			call "!bat_exedir!\WaitForFile.exe" rw "!bat_CAMS2QUEUE.queue_dir!\Temp\!bat_camera_group_start!\ValidationLog.txt"

		)
	)


:WAIT_FOR_GROUPS_END
!bat_poplog! [RETURN !bat_batchfile!:WAIT_FOR_GROUPS] [bat_returncode=!bat_returncode!, bat_targetdir="%~1"]
!bat_log!
rem !bat_WAIT! 0     :WAIT_FOR_GROUPS_END
!bat_return! !bat_returncode!





	REM #########################################################################
	REM Restore the FF files by moving them from their group dirs back to the source dir. 
	REM

:RESTORE_GROUPS	
!bat_pushlog! [CALL !bat_batchfile!:RESTORE_GROUPS] [%*]
!bat_echolog! Restoring the FF files by moving them from their group dirs back to the source dir. . 

	set bat_returncode=0

	set /a bat_camera_start=!bat_camera_first_stripped!
	set /a bat_camera_end=!bat_camera_start! + !bat_camera_group_size!


	for /L %%a in  (!bat_camera_start!, !bat_camera_group_size!, !bat_camera_last_stripped!) do (
		!bat_logexec! set bat_camera_group_start=%%a
		
		set /a bat_camera_group_end=!bat_camera_group_start! + !bat_camera_group_size! - 1
		
		!bat_echolog! set /a bat_camera_group_end=!bat_camera_group_start! + !bat_camera_group_size! - 1

		!bat_logexec! set bat_camera_group

			REM Loop through the groups 
		!bat_pushecho! for /L ..c in ^(!bat_camera_group_start!, 1, !bat_camera_group_end!^) do ...
		for                /L %%c in  (!bat_camera_group_start!, 1, !bat_camera_group_end!) do (
			!bat_pushecho! ^( ..c=%%c

			set bat_camera_temp_padded=

			!bat_logexec! set bat_camera_temp=%%c

			!bat_CALL! "!bat_exedir!\StripZeros.bat" "!bat_camera_temp!" "bat_camera_temp_padded"
			
			set bat_camera_temp_padded=000000!bat_camera_temp_padded!
			!bat_logexec! set bat_camera_temp_padded=!bat_camera_temp_padded:~-6!

			!bat_echolog! MOVE /Y "!bat_CAMS2QUEUE.queue_dir!\Temp\!bat_camera_group_start!\FF_!bat_camera_temp_padded!_*.*" "!bat_sourcedir!"
			              MOVE /Y "!bat_CAMS2QUEUE.queue_dir!\Temp\!bat_camera_group_start!\FF_!bat_camera_temp_padded!_*.*" "!bat_sourcedir!">nul:
			!bat_popecho! ^) %%c
		)
		
		!bat_echolog! MOVE /Y "!bat_CAMS2QUEUE.queue_dir!\Temp\!bat_camera_group_start!\ValidationLog.txt" "!bat_sourcedir!\ValidationLog_!bat_capturesession!_!bat_camera_group_start!.txt"
			      MOVE /Y "!bat_CAMS2QUEUE.queue_dir!\Temp\!bat_camera_group_start!\ValidationLog.txt" "!bat_sourcedir!\ValidationLog_!bat_capturesession!_!bat_camera_group_start!.txt"
			      
		if exist "!bat_CAMS2QUEUE.queue_dir!\Temp\!bat_camera_group_start!\FF_!bat_camera_temp_padded!_*.*" (
			set bat_returncode=1
			!bat_echolog!
			!bat_echolog! `   ERROR - MOVE FAILED:
			!bat_echolog! `           MOVE /Y "!bat_CAMS2QUEUE.queue_dir!\Temp\!bat_camera_group_start!\FF_!bat_camera_temp_padded!_*.*" "!bat_sourcedir!"
			!bat_echolog!
		) ELSE (
			!bat_logexec! DEL /Q "!bat_CAMS2QUEUE.queue_dir!\Temp\!bat_camera_group_start!\FFvalidityListing_All.txt"
			!bat_logexec! RD  /Q "!bat_CAMS2QUEUE.queue_dir!\Temp\!bat_camera_group_start!"
		)
	)

	set bat_returncode=0

:RESTORE_GROUPS_END
!bat_poplog! [RETURN !bat_batchfile!:RESTORE_GROUPS] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 0     :RESTORE_GROUPS_END
!bat_return! !bat_returncode!










	REM #########################################################################
	REM 

:HELP
	echo.%~0      Batch Script
	echo.
	echo.    Usage %~0 ^<dir^>  
	echo.
	echo.    Improves performance of the FTP_ValidateFFfiles.exe by dividing the files
	echo.    into smaller chunks and working on them in parallel.
	echo.
	echo.    The FTP_ValidateFFfiles.exe program renames bad FF files by replacing the
	echo.    ".bin" suffix with a ".bad" suffix. 
	echo.
	echo.    This script "moves" all the FF*.bin files in the specified dir to subdirectories of the 
	echo.    "!bat_CAMS2QUEUE.queue_dir\Temp!" directory.  Each execution of this script will 
	echo.    attempt to split the files into groups of cameras that each have 1/4 of the cameras. 
	echo.    
	echo.    Needs to:
	echo.     1] Create a camera list
	echo.     2] Determine the camera numbers to group the splits
	echo.     3] For each group:
	echo.        4] Clear out any directories in the Temp dir that have the same names as the first camera in the group
	echo.        5] Move all the files from the specified dir to the group dir
	echo.        6] Call the FTP_ValidateFFfiles.exe for the group dir
	echo.        7] Rename the ValidationLog.txt file with the session name and starting camera number
	echo.        8] Move ALL the files back to the source capturedfiles dir.
	echo.
	echo.     Example: 
	echo.        %~0 "C:\CAMS\CapturedFiles\2011_10_21_01_58_22"
	echo.
	echo.
!bat_return! 99






	REM #########################################################################
	REM 

:DONE
	!bat_popecho! [goto !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog! exit /b !bat_returncode!
exit /b !bat_returncode!
