REM Fetch From URL

@echo off
setlocal enableextensions enabledelayedexpansion


	REM #################################################################################
:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	if "%~1" equ "" goto :HELP

:CHECKHELP_END
goto :SETUP %*





	REM #################################################################################
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	!bat_CALL! "%~dp0indent_setup.bat"

	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - [%~dpnx0 %*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	
	set bat_returncode=0
	
	call "!bat_exedir!\ReadCams2Global.bat"

	set /a bat_boards_max=!bat_CAMS2BOARDS.number_of_boards!-1
	!bat_log! set bat_boards_max=!bat_boards_max!

REM Now loop through all the boards and only perform on the first one.  
REM For the first board, determine the first camera number, and then
REM perform the procedure below.  The output will be a file in the 
REM "x:\cams2_queue\weather\forecast_2018_05_29.html" dir and naming convention.
REM

	!bat_logexec! set bat_camera=%~1
	!bat_logexec! set bat_caldir=!bat_CAMS2DIR.0!\cal
	!bat_logexec! set bat_camerasitesfilefull=!bat_caldir!\camerasites.txt

	REM get the lat/long for the specific camera number from camerasites.txt that matches the camera number in the SubmissionFiles dir name.
	!bat_pushecho! for /f "usebackq tokens=1-8" ..a in ^(`findstr /i /v /c:"Cam#  Lat" /c:"----" "!bat_camerasitesfilefull!"][sort /+6][find /i "!bat_camera!"`^) do ^(...
	for                /f "usebackq tokens=1-8" %%a in  (`findstr /i /v /c:"Cam#  Lat" /c:"----" "!bat_camerasitesfilefull!"^|sort /+6^|find /i "!bat_camera!"`) do (
		!bat_echolog! a=%%a, b=%%b, c=%%c, d=%%d, e=%%e, f=%%f, g=%%g, h=%%h
		!bat_logexeclog! set bat_lat=%%b
		!bat_logexeclog! set bat_long=%%c

			REM If the bat_long is not prefixed with either "+" or "-", then add "+".
		(echo.!bat_long:~0,1!|findstr /i /r /c:[0-9]) && (!bat_logexec! set bat_long=+!bat_long!)

			REM Now, for bat_long that there is at least a "+", then change the sign from plus to minus or visa versa.
		if "!bat_long:~0,1!" equ "-" (
			!bat_logexec! set bat_long=!bat_long:-=!
		) ELSE (
			!bat_logexec! set bat_long=!bat_long:+=-!
		)
		
			REM Now, for bat_lat that there is a "+", then strip it.
		if "!bat_lat:~0,1!" equ "+" (
			!bat_logexec! set bat_lat=!bat_lat:+=!
		)
		
		

	)
	!bat_popecho! ^)

		rem Get the bat_date_cams  [e.g. 2018_05_29] so we can create the file name
	CALL "!bat_exedir!\GetDate2.bat"
	
	!bat_logexec! set bat_outfile_name=forecast_!bat_date_cams!_!bat_camera!
	!bat_logexec! set bat_outfile_full=!bat_CAMS2QUEUE.queue_dir!\weather\!bat_outfile_name!.html
	
	!bat_logexec! set bat_URL=https://clearoutside.com/forecast/!bat_lat!/!bat_long!?view=midday
	
rem	echo.powershell -command "& {iwr "!bat_URL!" -OutFile "!bat_outfile_full!" }"
rem	     powershell -command "& {iwr "!bat_URL!" -OutFile "!bat_outfile_full!" }"

	!bat_echolog! call cscript //nologo "!bat_exedir!\WeatherForecastWebFile.vbs" "!bat_URL!" "!bat_outfile_full!"
	              call cscript //nologo "!bat_exedir!\WeatherForecastWebFile.vbs" "!bat_URL!" "!bat_outfile_full!"
	     
	set bat_returncode=!errorlevel!

goto :DONE





	REM #################################################################################
	REM 

:HELP
	@echo off
	echo.
	echo.%~nx0
	echo.
	echo.Usage: %~nx0   "<camera>"
	echo.
	echo.Fetches a file or resource from the clearoutside URL and saves it in the 
	echo."bat_CAMS2QUEUE.queue_dir\weather\forecast_YYYY_MM_DD_<camera>.html" file.
	echo.
	echo.The result is stored into a local HTML file in the weather dir. 
	echo.
	echo.The ClearOutside URL is: 
	echo.   https://clearoutside.com/forecast/<latitude>/<longitude>?view=midday
	echo.
	echo.Note: It obtains the lat/long from the camerasites.txt file using the specified camera. However
	echo.      it should be noted that the camerasites.txt file has the longitude sign backward...
	echo.      that is, that west longitudes in the camerasites.txt file are positive, where
	echo.      clearoutside [and the rest of the world] use negative for west longitudes. 
	echo.      Therefore, this script fixes that. 
	echo.
	echo.Example:
	echo.   %~nx0   "000526"
	echo.

exit /b 99



:DONE
	echo.DONE [bat_returncode=!bat_returncode!]
	echo.
exit /b !bat_returncode!
