
@echo off
setlocal enableextensions enabledelayedexpansion

	REM #########################################################################
	REM 

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	
rem 	if /i "%~1" EQU "" (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

	REM #########################################################################
	REM 

:SETUP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	CALL "!bat_exedir!\ReadParams.bat"
	
	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!


rem set bat_indent_log_debug=true

		rem Get the bat_capturedfilesdir value
	CALL "!bat_exedir!\ReadConfig.bat"

	CALL "!bat_exedir!\ReadCams2Global.bat"

	set /a bat_boards_max=!bat_CAMS2BOARDS.number_of_boards!-1
	!bat_log! set bat_boards_max=!bat_boards_max!
	
goto :MAIN %*
	


	REM #########################################################################
	REM 

:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] [%*]
rem !bat_echolog! [!bat_batchfile!:MAIN] 1111111111111111111111111

		REM This block does a couple of things...
		REM  1) it iterates through all the boards' CAMS instances
		REM  2) It then loops through through all the capture sessions in the SubmissonFiles dir of each board
		REM  3) That establishes the capture session values as "bat_FTPdir"
		rem  4) Copies certain select files from the FTP dir of the SubmissionFiles session to the Submitted dir
		REM  5) Generates a zip file [or split zip] of the Submitted dir
		REM  6) Creates an md5.txt file of the zip file. 
		
	set bat_FTPdir=
	!bat_pushlog! for /L %%x in ^(0,1,!bat_boards_max!^) do ^(
	for               /L %%x in  (0,1,!bat_boards_max!) do (

		!bat_echolog!
		!bat_echolog!
		!bat_echolog! `------------- BOARD %%x -----------------------------
		!bat_echolog!
		!bat_echolog! ... Processing board=%%x of 0 to !bat_boards_max!

		set bat_returncode=0


		!bat_logexeclog! set bat_camsdir=!bat_CAMS2DIR.%%x!
		!bat_logexeclog! set bat_caldir=!bat_CAMS2DIR.%%x!\Cal
		
			REM If dir /ad "!bat_camsdir!\Submissionfiles\*.*" ][ FIND /i " 0 Dir(s)" 
			REM signals not found, then there are submission files to process becasue it's 
			REM looking for directories instead of files.
		!bat_pushlog! {dir /ad "!bat_camsdir!\SubmissionFiles\*.*"][find /i " 0 Dir(s)"{ II {
		(              dir /ad "!bat_camsdir!\SubmissionFiles\*.*"|find /i " 0 Dir(s)") || (

			!bat_pushlog! for /f "usebackq tokens=*" ..y in ^(`dir /b /ad /o-n "!bat_camsdir!\SubmissionFiles"`^) do ^(
			for               /f "usebackq tokens=*" %%y in  (`dir /b /ad /o-n "!bat_camsdir!\SubmissionFiles"`) do (

				!bat_logexeclog! set bat_FTPdir=!bat_camsdir!\SubmissionFiles\%%y\FTP

				!bat_log! Processing SubmissionFiles session: "!bat_FTPdir!"
				CALL :START_FTP "!bat_FTPdir!"
			)
			!bat_poplog! ^)	rem for /f "usebackq tokens=*" ..y in ^(`dir /b /ad "!bat_camsdir!\SubmissionFiles"`^)
		)
		!bat_poplog! ^) [dir /ad "!bat_camsdir!\SubmissionFiles\*.*"][FIND /i " 0 Dir(s)"
	)
	!bat_poplog! ^)	rem for /L %%x in ^(0,1,!bat_boards_max!^) do

:MAIN_END
!bat_poplog! [END-!bat_batchfile!:MAIN] - goto :DONE
!bat_log!
goto :DONE



	

	


	REM #########################################################################
	REM This routine acts as the main body of the script for each instance of a capture session.
	REM
	REM

:START_FTP	
!bat_pushecho! [CALL !bat_batchfile!:START_FTP] [%*]
!bat_echolog! Capture Session source dir: "!bat_FTPdir!"

rem !bat_echolog! [!bat_batchfile!:START_FTP] 55555555555555555555555

	    REM %~1 example: "D:\cams_board0\CAMS\SubmissionFiles\2017_12_24_000533_01_29_10\FTP"
	CALL "!bat_exedir!\ParseDir.bat" "!bat_FTPdir!"
	set bat_submissionfilesdir=!bat_retval1!&			REM "D:\cams_board0\CAMS\SubmissionFiles\2017_12_24_000533_01_29_10"
	
	CALL "!bat_exedir!\ParseDir.bat" "!bat_retval1!"
	set bat_submissionbasedir=!bat_retval1!
	set bat_submissionsession=!bat_retval2!&			REM "2017_12_24_000533_01_29_10"
	set bat_camera_first=!bat_submissionsession:~11,6!
	set bat_capturesession=!bat_submissionsession:~0,10!_!bat_submissionsession:~-8!&	REM "2017_12_24_01_29_10"
	set bat_captureddate=!bat_capturesession:~0,10!&					REM "2017_12_24"
	
	set bat_submitteddir=!bat_camsdir!\Submitted\!bat_submissionsession!
	
rem	!bat_CALL! "!bat_exedir!\ParseDir.bat" "!bat_retval1!"
rem	set bat_camsdir=!bat_retval1!
	
	set bat_capturedfilesdir=!bat_submissionbasedir!\CapturedFiles\!bat_capturesession!
	set bat_archivedfilesdir=!bat_submissionbasedir!\ArchivedFiles\!bat_capturesession!
	set bat_confirmedfilesdir=!bat_submissionbasedir!\ConfirmedFiles\!bat_capturesession!
	
		REM This is better than: IF EXIST "!bat_camsdir!\Submitted\*.*"
		REM because IF EXIST will return true if empty directories and stuff exist.
		REM This way will only return true if there "files" exist. 

	!bat_pushlog! {dir /a-d "!bat_camsdir!\Submitted\*.*"][find /i " 0 File(s)"} $$ {
	(              dir /a-d "!bat_camsdir!\Submitted\*.*"|find /i " 0 File(s)") && (

		!bat_log! Cleaning up 'sub-directories' in preparation for next capture session...
		!bat_pushlog! for /f "usebackq tokens=*" ..z in ^(`dir /b /ad /on "!bat_camsdir!\Submitted"`^) do ^(
		for               /f "usebackq tokens=*" %%z in  (`dir /b /ad /on "!bat_camsdir!\Submitted"`) do (

			if exist "!bat_camsdir!\Submitted\%%z\*.*" (
				!bat_logexeclog! DEL /Q /S "!bat_camsdir!\Submitted\%%z\*.*"
			)

			if exist "!bat_camsdir!\Submitted\%%z" (
				!bat_logexeclog! RD  /Q    "!bat_camsdir!\Submitted\%%z"
			)
		)
		!bat_poplog! ^)
	)
	!bat_poplog! ^) {dir /a-d "!bat_camsdir!\Submitted\*.*"][find /i " 0 File(s)"} 


	(dir /a-d "!bat_camsdir!\Submitted\*.*"|find /i " 0 File(s)") && (
		!bat_logexec! dir "!bat_camsdir!\Submitted\*.*"
		!bat_log! Cleaning up 'zip and other files' that remain in the Submitted dir in preparation for next capture session...
		!bat_pushlog! for /f "usebackq tokens=*" ..z in ^(`dir /b /a-d /on "!bat_camsdir!\Submitted\*.*"`^) do ^(
		for               /f "usebackq tokens=*" %%z in  (`dir /b /a-d /on "!bat_camsdir!\Submitted\*.*"`) do (
			!bat_logexeclog! DEL /Q "!bat_camsdir!\Submitted\%%z\*.*"
		)
		!bat_poplog! ^)
	)
	

	CALL :CHECKCONTINUE
	!bat_log! bat_returncode=!bat_returncode!
	if "!bat_returncode!" neq "0" (goto :START_FTP_END)
	
	!bat_echolog!
	!bat_echolog! *** Found a capture session to queue to submit: "!bat_FTPdir!"
	!bat_echolog!
	
	CALL :CREATEDIRS
	if "!bat_returncode!" neq "0" (goto :START_FTP_END)
	
	CALL :COPYDETECT
	if "!bat_returncode!" neq "0" (goto :START_FTP_END)
	
	CALL :COPYWEATHER
	
	CALL :COPYCAL
	if "!bat_returncode!" neq "0" (goto :START_FTP_END)
	
	CALL :COPYFF
rem	if "!bat_returncode!" neq "0" (goto :START_FTP_END)

	CALL :COPYTHUMBNAILS
rem	if "!bat_returncode!" neq "0" (goto :START_FTP_END)
	
	CALL :MAKEZIP
	if "!bat_returncode!" neq "0" (goto :START_FTP_END)
	
	CALL :MAKEMD5
	if "!bat_returncode!" neq "0" (goto :START_FTP_END)
	
	CALL :MOVE_TO_QUEUE

	CALL :REMOVESUBMITTED
	
:START_FTP_END
!bat_popecho! [RETURN !bat_batchfile!:START_FTP] [bat_returncode=!bat_returncode!]
!bat_echolog!
rem !bat_WAIT! 0     :START_FTP_END
!bat_return! !bat_returncode!





	REM #########################################################################
	REM This routine determines whether this capture set has already been zipped.
	REM
	REM Even if there is a zip, if the files are still in Submitted, the zip needs
	REM to be rebuilt.
	REM 
	REM !bat_submissionsession!*.zip.md5.txt must not exist in the Transmitted dir of the board
	REM !bat_submissionsession!*.zip.md5.txt must not exist in the Submitted dir of the board
	REM !bat_submissionsession!*.zip.md5.txt must not exist in the queue dir
	REM !bat_submissionsession!*.zip.md5.txt must not exist in the Transmitted dir of the queue
	REM !bat_submissionsession!*.zip.md5.txt must not exist on the FTP server
	REM
	REM Then there is another problem because if this was created with split zips, it needs
	REM to check for all the sequence files. [!bat_submissionsession!*.zip.001.md5.txt]
	REM
	REM Returns:
	REM  bat_returncode              0=continue creating new zip or recreating the zip if one already exists in certain circumstances
	REM                              Any other value means that the zip already exists, so skip it. 

:CHECKCONTINUE
!bat_pushecho! [CALL !bat_batchfile!:CHECKCONTINUE] %*

!bat_echolog! This routine determines whether this capture set has already been zipped...
	set bat_returncode=1

REM *********************************** bat_camsdir *********************************

rem	!bat_echolog! if exist                                    "!bat_camsdir!\Transmitted\!bat_submissionsession!*.zip.md5.txt" 
	if               exist                                    "!bat_camsdir!\Transmitted\!bat_submissionsession!*.zip.md5.txt" (
		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /o-n   "!bat_camsdir!\Transmitted\!bat_submissionsession!*.zip.md5.txt"`) do (
			!bat_log! `      **** SKIPPING - ALREADY EXISTS [1]: "!bat_camsdir!\Transmitted\%%a" 
		)
		goto :CHECKCONTINUE_END
	)
	
rem	!bat_echolog! if exist                                    "!bat_camsdir!\Transmitted\!bat_submissionsession!*.zip" 
	if               exist                                    "!bat_camsdir!\Transmitted\!bat_submissionsession!*.zip" (
		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /o-n   "!bat_camsdir!\Transmitted\!bat_submissionsession!*.zip" `) do (
			!bat_log! `      **** SKIPPING - ALREADY EXISTS [2]: "!bat_camsdir!\Transmitted\%%a" 
		)
		goto :CHECKCONTINUE_END
	)

rem	!bat_echolog! if exist                                    "!bat_camsdir!\Transmitted\!bat_submissionsession!*.zip.???.md5.txt" 
	if               exist                                    "!bat_camsdir!\Transmitted\!bat_submissionsession!*.zip.???.md5.txt" (
		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /o-n   "!bat_camsdir!\Transmitted\!bat_submissionsession!*.zip.???.md5.txt" `) do (
			!bat_log! `      **** SKIPPING - ALREADY EXISTS [3]: "!bat_camsdir!\Transmitted\%%a"
		)
		goto :CHECKCONTINUE_END
	)

rem	!bat_echolog! if exist                                    "!bat_camsdir!\Transmitted\!bat_submissionsession!*.zip.???" 
	if               exist                                    "!bat_camsdir!\Transmitted\!bat_submissionsession!*.zip.???" (
		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /o-n   "!bat_camsdir!\Transmitted\!bat_submissionsession!*.zip.???" `) do (
			!bat_log! `      **** SKIPPING - ALREADY EXISTS [4]: "!bat_camsdir!\Transmitted\%%a" 
		)
		goto :CHECKCONTINUE_END
	)

REM *********************************** bat_CAMS2QUEUE.queue_dir\Transmitted *********************************

rem	!bat_echolog! if exist                                    "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_submissionsession!*.zip.md5.txt" 
	if               exist                                    "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_submissionsession!*.zip.md5.txt" (
		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /o-n   "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_submissionsession!*.zip.md5.txt" `) do (
			!bat_log! `      **** SKIPPING - ALREADY EXISTS [5]: "!bat_CAMS2QUEUE.queue_dir!\Transmitted\%%a"
		)
		goto :CHECKCONTINUE_END
	)
	
rem	!bat_echolog! if exist                                    "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_submissionsession!*.zip" 
	if               exist                                    "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_submissionsession!*.zip" (
		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /o-n   "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_submissionsession!*.zip" `) do (
			!bat_log! `      **** SKIPPING - ALREADY EXISTS [6]: "!bat_CAMS2QUEUE.queue_dir!\Transmitted\%%a" 
		)
		goto :CHECKCONTINUE_END
	)

rem	!bat_echolog! if exist                                    "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_submissionsession!*.zip.???.md5.txt" 
	if               exist                                    "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_submissionsession!*.zip.???.md5.txt" (
		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /o-n   "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_submissionsession!*.zip.???.md5.txt" `) do (
			!bat_log! `      **** FOUND - ALREADY EXISTS - skip [7]: "!bat_CAMS2QUEUE.queue_dir!\Transmitted\%%a"
		)
		goto :CHECKCONTINUE_END
	)

rem	!bat_echolog! if exist                                    "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_submissionsession!*.zip.???" 
	if               exist                                    "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_submissionsession!*.zip.???" (
		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /o-n   "!bat_CAMS2QUEUE.queue_dir!\Transmitted\!bat_submissionsession!*.zip.???" `) do (
			!bat_log! `      **** SKIPPING - ALREADY EXISTS [8]: "!bat_CAMS2QUEUE.queue_dir!\Transmitted\%%a" 
		)
		goto :CHECKCONTINUE_END
	)

REM *********************************** bat_CAMS2QUEUE.queue_dir *********************************

rem	!bat_echolog! if exist                                    "!bat_CAMS2QUEUE.queue_dir!\!bat_submissionsession!*.zip.md5.txt" 
	if               exist                                    "!bat_CAMS2QUEUE.queue_dir!\!bat_submissionsession!*.zip.md5.txt" (
		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /o-n   "!bat_CAMS2QUEUE.queue_dir!\!bat_submissionsession!*.zip.md5.txt" `) do (
			!bat_log! `      **** SKIPPING - ALREADY EXISTS [9]: "!bat_CAMS2QUEUE.queue_dir!\%%a"
		)
		goto :CHECKCONTINUE_END
	)

rem	!bat_echolog! if exist                                    "!bat_CAMS2QUEUE.queue_dir!\!bat_submissionsession!*.zip.???.md5.txt" 
	if               exist                                    "!bat_CAMS2QUEUE.queue_dir!\!bat_submissionsession!*.zip.???.md5.txt" (
		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /o-n   "!bat_CAMS2QUEUE.queue_dir!\!bat_submissionsession!*.zip.???.md5.txt" `) do (
			!bat_log! `      **** SKIPPING - ALREADY EXISTS [10]: "!bat_CAMS2QUEUE.queue_dir!\%%a"
		)
		goto :CHECKCONTINUE_END
	)
	
		REM ************************************************************
		REM ************************************************************
		REM Create or Recreate the zip file...
	
	!bat_log! `   **** New Zip file should be created and queued: !bat_submissionsession!
	set bat_returncode=0
	
		rem if we find a matching file in the Submitted dir, it probably doesn't contain the correct files
		rem so we should rebuild it using this script.
		
rem	!bat_echolog! if exist                                    "!bat_camsdir!\Submitted\!bat_submissionsession!*.zip" 
	if               exist                                    "!bat_camsdir!\Submitted\!bat_submissionsession!*.zip" (
		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /o-n   "!bat_camsdir!\Submitted\!bat_submissionsession!*.zip" `) do (
			!bat_log! `      **** FOUND [11] "!bat_camsdir!\Submitted\!bat_submissionsession!*.zip" - but REPLACING: "!bat_camsdir!\Submitted\%%a"
		)
		goto :CHECKCONTINUE_END
	)

rem	!bat_echolog! if exist                                    "!bat_CAMS2QUEUE.queue_dir!\!bat_submissionsession!*.zip.???" 
	if               exist                                    "!bat_CAMS2QUEUE.queue_dir!\!bat_submissionsession!*.zip.???" (
		for /f "usebackq tokens=*" %%a in (`dir /b /a-d /o-n   "!bat_CAMS2QUEUE.queue_dir!\!bat_submissionsession!*.zip.???" `) do (
			!bat_log! `      **** FOUND [12] "!bat_CAMS2QUEUE.queue_dir!\!bat_submissionsession!*.zip.???" - but REPLACING: "!bat_CAMS2QUEUE.queue_dir!\%%a" 
		)
		goto :CHECKCONTINUE_END
	)

:CHECKCONTINUE_END
!bat_popecho! [RETURN !bat_batchfile!:CHECKCONTINUE] [bat_returncode=!bat_returncode!, zip files names starting with bat_submissionsession=!bat_submissionsession!]
!bat_echolog!
rem !bat_WAIT! 0     :CHECKCONTINUE_END
!bat_return! !bat_returncode!




	REM #########################################################################
	REM Creates the "...\Submitted\!bat_submissionsession!" directory
	REM

:CREATEDIRS
!bat_pushlog! [CALL !bat_batchfile!:CREATEDIRS] %*

	set bat_returncode=1

	!bat_logexeclog! MD "!bat_camsdir!\Submitted\!bat_submissionsession!"

	set bat_returncode=0

:CREATEDIRS_END
!bat_poplog! [RETURN !bat_batchfile!:CREATEDIRS] [bat_returncode=!bat_returncode!]
!bat_log!
rem !bat_WAIT! 0     :CREATEDIRS_END
!bat_return! !bat_returncode!





	REM #########################################################################
	REM Copies the detect files to Submitted...

:COPYDETECT
!bat_pushecho! [CALL !bat_batchfile!:COPYDETECT] %*
!bat_echolog! Copying the detect files to Submitted...

	set bat_returncode=1

		rem If bat_CAMS2ZIP.2 is defined, then it contains "ftpdetectinfo_*.txt"
	if defined bat_CAMS2ZIP.2 (
		!bat_logexec! COPY /y "!bat_FTPdir!\FTPdetectinfo_*.txt"   "!bat_submitteddir!"
		!bat_logexec! COPY /y "!bat_FTPdir!\CameraTimeOffsets.txt"   "!bat_submitteddir!"
	)
	
	set bat_returncode=0

:COPYDETECT_END
!bat_popecho! [RETURN !bat_batchfile!:COPYDETECT] [bat_returncode=!bat_returncode!]
!bat_echolog!
!bat_return! !bat_returncode!







	REM #########################################################################
	REM Copies the matching weather file to FTP and Submitted...
	REM First, it ensures the Weather dir exists
	REM Then it "moves" the forecast file to the FTP dir.
	REM Then it copies the forecast file [if set to do so] to the submitted/zip
	REM
	REM Note: Because the forecast file is created before the session starts, we move ALL 
	REM       forecast files matching the bat_first_camera to the FTP dir of the current SubmissionsFiles session, 
	REM       regardless of the date or the CAMS date in the name of the forecast file.  The date in the name
	REM       of the forecast file comes from running GetDate2.bat script during LaunchCapture_KILL.bat around
	REM       4:30 pm local time... before capture starts and before there is any information about what
	REM       the capture session name will be. 

:COPYWEATHER
!bat_pushecho! [CALL !bat_batchfile!:COPYWEATHER] %*

	set bat_returncode=1
	
		REM Create the Weather folder if it doesn't exist.
	if not exist "!bat_CAMS2QUEUE.queue_dir!\Weather" (
		!bat_logexeclog! MD "!bat_CAMS2QUEUE.queue_dir!\Weather"
	)

		REM Move the forecast file to the FTP dir so that it is included in the archives and possibly the zip.
	!bat_pushlog! if exist "!bat_CAMS2QUEUE.queue_dir!\Weather\forecast_!bat_captureddate!_!bat_camera_first!.html" ^(
	if               exist "!bat_CAMS2QUEUE.queue_dir!\Weather\forecast_!bat_captureddate!_!bat_camera_first!.html" (
		!bat_logexec! MOVE /Y "!bat_CAMS2QUEUE.queue_dir!\Weather\forecast_*_!bat_camera_first!.html" "!bat_FTPdir!"
	)
	!bat_poplog! ^)


		REM Only include the forecast file in  the zip file if cams2global.ini says to include it. 
	if /i "!bat_CAMS2UPLOAD.include_forecast!" equ "true" (
			rem If bat_CAMS2ZIP.2 is defined, then it contains "ftpdetectinfo_*.txt"
		if defined bat_CAMS2ZIP.2 (

			if exist "!bat_FTPdir!\forecast_!bat_captureddate!_!bat_camera_first!.html" (

					rem Now copy the weather forecast file to the FTP dir and to the Submitted dir
					rem The issue is to match the date of the weather forecast file to the capture session
				set bat_captureddate=!bat_submissionsession:~0,10!
				!bat_logexec! COPY /Y "!bat_FTPdir!\forecast_!bat_captureddate!_!bat_camera_first!.html" "!bat_submitteddir!"
			)
		)
	)

	
	set bat_returncode=0

:COPYWEATHER_END
!bat_popecho! [RETURN !bat_batchfile!:COPYWEATHER] [bat_returncode=!bat_returncode!]
!bat_echolog!
!bat_return! !bat_returncode!





	REM #########################################################################
	REM 

:COPYCAL
!bat_pushecho! [CALL !bat_batchfile!:COPYCAL] %*
	!bat_echolog! Copy the detect file, cal files, and all the files matching !bat_CAMS2ZIP

	set bat_returncode=1

	set bat_captureddate=!bat_capturesession:~0,10!
	set bat_capturedtime=!bat_capturesession:~-8!
	
	set bat_caldate=!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!
	set bat_caltime=!bat_capturedtime:~0,2!!bat_capturedtime:~3,2!!bat_capturedtime:~-2!

	set bat_caldate=!bat_caldate!_!bat_caltime!

		rem If bat_CAMS2ZIP.1 is defined, then it means cal*.txt
	if defined bat_CAMS2ZIP.1 (
		!bat_logexec! COPY /y "!bat_FTPdir!\!bat_CAMS2ZIP.1!"   "!bat_submitteddir!"
	)
	
	set bat_returncode=0

:COPYCAL_END
!bat_popecho! [RETURN !bat_batchfile!:COPYCAL] [bat_returncode=!bat_returncode!]
!bat_echolog!
!bat_return! !bat_returncode!






	REM #########################################################################
	REM Copying 'qualified' local midnight FF files to Submitted 

:COPYFF
!bat_pushecho! [CALL !bat_batchfile!:COPYFF] %*
	!bat_echolog! Copying 'qualified' local midnight FF files to Submitted...

	set bat_returncode=1

		rem get bat_date_first.  It's needed whether bat_CAMS2ZIP.FF_disabled is true or false
	CALL :GETFIRSTFILE
	if "!bat_returncode!" neq "0" goto :COPYFF_END
	
	
		rem "!bat_CAMS2ZIP.FF_disabled!", when "true", it means that NO FF files at all will be copied.
		rem Otherwise, 
	if /i "!bat_CAMS2ZIP.FF_disabled!" equ "true" (
	
		set bat_returncode=0
		
		!bat_log! [!bat_batchfile!:SKIPPING ::COPYFF] [bat_CAMS2ZIP.FF_disabled=!bat_CAMS2ZIP.FF_disabled!]
		goto :COPYFF_END
		
	)&	rem if /i "!bat_CAMS2ZIP.FF_disabled!" neq "true" 
	
		REM Look for FF files that are BEFORE bat_date_first...
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir /b /a-d /on "!bat_FTPdir!\FF*.bin"`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`dir /b /a-d /on "!bat_FTPdir!\FF*.bin"`) do (
			!bat_logexeclog! set bat_tempfile=%%a&	REM FF_000532_20171210_063739_244_0014848.bin

			set bat_tempdatetime=!bat_tempfile:~-31!
			set bat_tempdatetime=!bat_tempdatetime:~0,15!

				rem If the FF file in the FTP dir is earlier than this capture session, then copy it.
				rem That's because Steve's LaunchCapture.exe preps the FTP dir with FF files that match
				rem the cal files, but if a camera failed to cal, then the matching FF file for the 
				rem most recent cal for that camera has been placed in the FTP dir.  So, if it's
				rem BEFORE the first camera's first FF*_0000000.bin file, then that camera did not cal
				rem this time and we can use the old file. 
			if /i "!bat_CAMS2ZIP.include.2!" EQU "old FF" (
				if /i "!bat_tempdatetime!" LSS "!bat_date_first!" (
					!bat_logexec! COPY /Y "!bat_FTPdir!\!bat_tempfile!"   "!bat_submitteddir!"
				)
			) else (
				!bat_logexec! COPY /Y "!bat_FTPdir!\!bat_tempfile!"   "!bat_submitteddir!"
			)

		)
	!bat_poplog! ^)

	set bat_returncode=0

:COPYFF_END
!bat_popecho! [RETURN !bat_batchfile!:COPYFF] [bat_returncode=!bat_returncode!]
!bat_echolog!
rem !bat_WAIT! 5 COPYFF_END
rem !bat_pause! 456
!bat_return! !bat_returncode!






	REM #########################################################################
	REM Determines the first camera and first date of the capture session
	REM 
	REM Returns:
	REM    bat_camera_first
	REM    bat_date_first
	REM

:GETFIRSTFILE
!bat_pushlog! [CALL !bat_batchfile!:GETFIRSTFILE] %*
	!bat_log! Determining the first camera and first date of the capture session...

	set bat_returncode=1
	
	set bat_tempfile=
	set bat_date_first=
	set bat_camera_first=

	if not defined bat_submissionsession (
		!bat_echolog!
		!bat_echolog! `    ERROR [!bat_returncode!] - bat_submissionsession variable is not defined and it should be...
		!bat_echolog!
		goto :GETFIRSTFILE_END
	)

	!bat_pushlog! for /f "usebackq tokens=1-10* delims=_." ..a in ^('!bat_submissionsession!'^) do ^(
	for               /f "usebackq tokens=1-10* delims=_." %%a in  ('!bat_submissionsession!') do (
		echo.yyyy=%%a,mm=%%b,day=%%c,cccccc=%%d,hh=%%e,mi=%%f,se=%%g
		
		set bat_camera_first=%%d
		set bat_date_first=%%a%%b%%c_%%e%%f%%g
		
		!bat_echolog! bat_camera_first=!bat_camera_first!
		!bat_echolog! bat_date_first=!bat_date_first!
		set bat_returncode=0
	)
	!bat_poplog! ^)

	goto :GETFIRSTFILE_END


%BAT_COMMENT_BEGIN% block comment this section since the previous section is quicker and makes this obsolete...

	set bat_temp_FF_dir=!bat_submissionfilesdir!\CapturedFiles\!bat_capturesession!

	if NOT EXIST "!bat_temp_FF_dir!\FF_*_????????_??????_???_0000000.bin" (
	
		set bat_temp_FF_dir=!bat_submissionfilesdir!\CapturedFiles\!bat_capturesession!\FF_*_????????_??????_???_0000000.bin
		set bat_returncode=2
		!bat_echolog!
		!bat_echolog! `    ERROR [!bat_batchfile!:GETFIRSTCAMERA:!bat_returncode!] - No matching files: "!bat_submissionfilesdir!\CapturedFiles\!bat_capturesession!\FF_*_????????_??????_???_0000000.bin"
		!bat_echolog!
		goto :GETFIRSTFILE_END
	)

	!bat_echolog! for /f "usebackq tokens=*" ..a in ^(`dir /b /a-d /o-n "!bat_temp_FF_dir!\FF_*_????????_??????_???_0000000.bin"`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`dir /b /a-d /o-n "!bat_temp_FF_dir!\FF_*_????????_??????_???_0000000.bin"`) do (
		set bat_tempfile=%%~na
	)
	
	if DEFINED bat_tempfile (
	
		if /i "!bat_tempfile:~9,1!" equ "_" (
			set bat_camera_first=!bat_tempfile:~3,6!
		) ELSE (
				rem it's the old-style cams 1.x version of FF file, which isn't compatible
			set bat_returncode=3
			!bat_echolog!
			!bat_echolog! `   ERROR [!bat_batchfile!:GETFIRSTCAMERA:!bat_returncode!] - it's the old-style cams 1.x version of FF file, which isn't compatible
			!bat_echolog! `         "!bat_submissionfilesdir!\CapturedFiles\!bat_capturesession!\!bat_tempfile!"
			!bat_echolog!
			goto :GETFIRSTFILE_END
		)
	
		!bat_logexeclog! set bat_tempfile
		!bat_logexeclog! set bat_camera_first=!bat_tempfile:~3,6!
		!bat_logexeclog! set bat_tempfile=!bat_tempfile:~-27!
		!bat_logexeclog! set bat_date_first=!bat_tempfile:~0,15!
		set bat_returncode=0
	)
%BAT_COMMENT_END%	

:GETFIRSTFILE_END
!bat_poplog! [RETURN !bat_batchfile!:GETFIRSTFILE] [bat_returncode=!bat_returncode!, bat_camera_first=!bat_camera_first!, bat_date_first=!bat_date_first!]
!bat_log!
set bat_temp_FF_dir=
!bat_return! !bat_returncode!






	REM #########################################################################
	REM 
	REM "!bat_CAMS2ZIP.include.1!' = "no thumbnails" means to skip thumbnails. Any other value means to include them. 

:COPYTHUMBNAILS
!bat_pushecho! [CALL !bat_batchfile!:COPYTHUMBNAILS] %*
	!bat_echolog! Copying Thumbnails to Submitted if bat_CAMS2ZIP.include.1 is set to do so...

	!bat_echolog! bat_CAMS2ZIP.INCLUDE.1=!bat_CAMS2ZIP.include.1!
	!bat_echolog! ` "bat_CAMS2ZIP.include.1" = "no thumbnails" means to skip thumbnails. Any other value means to include them. 

	set bat_returncode=0
	
	if /i "!bat_CAMS2ZIP.include.1!" EQU "no thumbnails" (
		goto :COPYTHUMBNAILS_END
	)

	!bat_logexec! COPY /y "!bat_FTPdir!\Thumbnail*.bmp"   "!bat_submitteddir!" 	
	
	
:COPYTHUMBNAILS_END
!bat_popecho! [RETURN !bat_batchfile!:COPYTHUMBNAILS] [bat_returncode=!bat_returncode!]
!bat_echolog!
!bat_return! !bat_returncode!





	REM #########################################################################
	REM Zip the submitted dir folder.
	REM Adds the "_01" sequence suffix to the zip file to start with.  During upload, 
	REM this sequence number will increment if:
	REM   A) A file with the same name/sequence number already exists on the FTP server;
	REM   B) AND the 

:MAKEZIP
!bat_pushecho! [CALL !bat_batchfile!:MAKEZIP] %*
	!bat_echolog! Zip the Submitted dir folder...

		REM Delete the target zip file AND its md5 file to prevent other scripts from thinking
		REM the zip file is done before it is. 
	
	!bat_logexeclog! set bat_zipfilefull=!bat_submitteddir!_01.zip
	!bat_logexeclog! set bat_md5filefull=!bat_submitteddir!_01.zip.md5.txt
	
	!bat_logexeclog! DEL /Q "!bat_zipfilefull!">nul: 2>&1
	!bat_logexeclog! DEL /Q "!bat_md5filefull!">>nul: 2>&1

	!bat_log! bat_CAMS2ZIP.split_enabled="!bat_CAMS2ZIP.split_enabled"

	if /i "!bat_CAMS2ZIP.split_enabled!" equ "true" (
		!bat_CALLecho! "!bat_exedir!\7zip.bat" -v!bat_CAMS2ZIP.split_size! "!bat_zipfilefull!"   "!bat_submitteddir!\*.*"
		set bat_returncode=!errorlevel!
		
		REM Since this is a split zip, we need to now create the "control" file so that we can transmit it
		REM to the server, then the server can read  the control file to determine if they have all the files.
		REM
		
		if exist "!bat_zipfilefull!.001" (
			!bat_log! Make MD5 of the zip file [!bat_submissionsession!_01.zip.???]...
			PUSHD "!bat_camsdir!\Submitted"
	rem			!bat_logexeclog! md5 -o"2018_01_15_000525_01_02_03_01.zip.ctl.txt"   2018_01_15_000525_01_02_03_01.zip.???
				!bat_logexeclog! md5 -o"!bat_camsdir!\Submitted\!bat_submissionsession!_01.zip.ctl.txt"      !bat_submissionsession!_01.zip.???
				
			POPD
		)
		
	) else (
		!bat_CALLecho! "!bat_exedir!\7zip.bat"  "!bat_zipfilefull!"   "!bat_submitteddir!\*.*"
		set bat_returncode=!errorlevel!
	)


:MAKEZIP_END
!bat_popecho! [RETURN !bat_batchfile!:MAKEZIP] [bat_returncode=!bat_returncode!, 
!bat_log! `                                 bat_zipfilefull="!bat_zipfilefull!", 
!bat_log! `                                 bat_md5filefull="!bat_md5filefull!"]
!bat_echolog!

!bat_return! !bat_returncode!







	REM #########################################################################
	REM Creates the .md5.txt file for the specified .zip file. 
	REM 
	REM Carefull: The MD5Create.bat script called in this routine will use the
	REM           bat_zipfilefull variable as the root name for a split zip
	REM           if bat_CAMS2ZIP.split_enabled=true. 

:MAKEMD5
!bat_pushecho! [CALL !bat_batchfile!:MAKEMD5] %*

	!bat_CALLecho! "!bat_exedir!\MD5CreateFile.bat" "!bat_zipfilefull!"
	set bat_returncode=!errorlevel!

:MAKEMD5_END
!bat_popecho! [RETURN !bat_batchfile!:MAKEMD5] [bat_returncode=!bat_returncode!, bat_md5=!bat_md5!, bat_hash=!bat_hash!]
!bat_echolog!
!bat_return! !bat_returncode!







	REM #########################################################################
	REM 			:REMOVESUBMITTED
	REM

:REMOVESUBMITTED
!bat_pushlog! [CALL !bat_batchfile!:REMOVESUBMITTED] %*

	!bat_logexeclog! DEL /Q "!bat_submitteddir!"
	!bat_logexeclog! RD  /Q "!bat_submitteddir!"


:REMOVESUBMITTED_END
!bat_poplog! [RETURN !bat_batchfile!:REMOVESUBMITTED] [bat_returncode=!bat_returncode!, bat_md5=!bat_md5!]
!bat_log!
!bat_return! !bat_returncode!





	REM #########################################################################
	REM Move zip and md5 files from Submitted to the queue dir
	REM 

:MOVE_TO_QUEUE
!bat_pushecho! [CALL !bat_batchfile!:MOVE_TO_QUEUE] %*
	!bat_echolog! Moving zip and md5 files from Submitted to the queue dir...

	if exist "!bat_camsdir!\Submitted\*.md5.txt" (
		for /f "usebackq tokens=*" %%a in (`dir /b "!bat_camsdir!\Submitted\*.md5.txt"`) do (
			!bat_logexec! MOVE /Y "!bat_camsdir!\Submitted\%%a"   "!bat_CAMS2QUEUE.queue_dir!"
		)
	)

	if exist "!bat_camsdir!\Submitted\*.zip" (
		for /f "usebackq tokens=*" %%a in (`dir /b "!bat_camsdir!\Submitted\*.zip"`) do (
			!bat_logexec! MOVE /Y "!bat_camsdir!\Submitted\%%a"   "!bat_CAMS2QUEUE.queue_dir!"
		)
	)

	if exist "!bat_camsdir!\Submitted\*.zip.???" (
		for /f "usebackq tokens=*" %%a in (`dir /b "!bat_camsdir!\Submitted\*.zip.???"`) do (
			!bat_logexec! MOVE /Y "!bat_camsdir!\Submitted\%%a"   "!bat_CAMS2QUEUE.queue_dir!"
		)
	)

	if exist "!bat_camsdir!\Submitted\*.zip.ctl.txt" (
		for /f "usebackq tokens=*" %%a in (`dir /b "!bat_camsdir!\Submitted\*.zip.ctl.txt"`) do (
			!bat_logexec! MOVE /Y "!bat_camsdir!\Submitted\%%a"   "!bat_CAMS2QUEUE.queue_dir!"
		)
	)


:MOVE_TO_QUEUE_END
!bat_popecho! [RETURN !bat_batchfile!:MOVE_TO_QUEUE] [bat_returncode=!bat_returncode!!]
!bat_echolog!
rem !bat_WAIT! 0	:MOVE_TO_QUEUE_END
!bat_return! !bat_returncode!






	REM #########################################################################
	REM 

:HELP
	echo.%~0      Batch Script
	echo.
	echo.     Usage %~0 ^<FTP dir^>  
	echo.
	echo.    Creates an alternative zip file from the SubmissionFiles\...\FTP dir. 
	echo.       1] Determine if there is anything to do.  Example, is the zip already
	echo.          in the Transmitted dir? 
	echo.       2] Create the Submitted subdir - same name as the SubmissionFiles dir.
	echo.       3] Copy the FTPdetectinfo_*.txt files to Submitted\...
	echo.       4] Determine the first FF file, based on "FF_^<first camera^>_YYYYMMDD_hhmmss_uu_0000000.bin".
	echo.          Any CAL files in the FTP dir that are "before" that means that those cameras need to
	echo.          include the "...\FTP\FF_^<camera^>_*.bin" to the Submitted dir. 
	echo.       5] Zip the Submitted dir.
	echo.       6] Make a "*.zip.md5.txt" file.
	echo.       7] When it's done, it MOVEs these files to the queue folder.
	echo.
	echo.     Example: 
	echo.        %~0 "C:\CAMS\SubmissionFiles\2011_10_21_000533_01_58_22\FTP"
	echo.
	echo.    The FTP directory must be a fully qualified name with the drive letter. Typically, 
	echo.    this directory is the FTP subdir.
	echo.
	echo.    The CapturedFiles dir used to determine the First FF file is from the SubmissionFiles dir. 
	echo.
	echo. IMPORTANT: This script needs another script to loop through all the CAMS instances [!bat_CAMS2DIR.0!]
	echo.
!bat_return! 99






	REM #########################################################################
	REM 

:DONE
	!bat_popecho! [goto !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog! exit /b !bat_returncode!
exit /b !bat_returncode!
